import 'package:appwrite_platform_test/appwrite.dart';
import 'package:flutter/material.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: HomePage(),
    );
  }
}

class HomePage extends StatefulWidget {
  @override
  _HomePageState createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> {
  late Client client;
  late Locale locale;
  late Account account;
  @override
  void initState() {
    super.initState();
    client = Client()
        .setEndpoint('https://demo.appwrite.io/v1')
        .setProject('608fa1dd20ef0');
    locale = Locale(client);
    account = Account(client);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Home Page'),
      ),
      body: ListView(
        padding: const EdgeInsets.all(16.0),
        children: <Widget>[
          TextButton(
            onPressed: () async {
              final response = await locale.getCountries();
              print(response.body);
            },
            child: Text("Countries"),
          ),
          TextButton(
            onPressed: () async {
              final response = await account.create(
                  email: "hello@gmail.com", password: "password");
              print(response.body);
            },
            child: Text("Create Account"),
          ),
          TextButton(
            onPressed: () async {
              final response = await account.createSession(
                  email: "hello@gmail.com", password: "password");
              print(response.body);
              final res2 = await account.get();
              print(res2.body);
            },
            child: Text("Create Session"),
          ),
        ],
      ),
    );
  }
}
