import 'client.dart';
import 'package:http/http.dart' as req;
import 'enums.dart';
import 'package:dio/dio.dart' as dio;

abstract class BaseClient implements Client {
  /// Your project ID
  BaseClient setProject(String value);

  /// Your secret JSON Web Token
  BaseClient setJWT(String value);

  BaseClient setLocale(value);

  BaseClient setSelfSigned({bool status = true});

  BaseClient setEndpoint(String endPoint);

  Future<req.Response> call(
    HttpMethod method, {
    String path = '',
    Map<String, String> headers = const {},
    Map<String, dynamic> params = const {},
    dio.ResponseType? responseType,
  });
}
