//ref for setting client specific options
//https://gist.github.com/jakemac53/204d6adfe04eafa7e4d432fa77b3b4b1
import 'package:http/http.dart' as req;
import 'enums.dart';
import 'package:dio/dio.dart' as dio;
import 'client_stub.dart'
    if (dart.library.html) 'browser_client.dart'
    if (dart.library.io) 'io_client.dart';

abstract class Client {
  late Map<String, String> config;
  late String endPoint;
  late dynamic cookieJar;

  factory Client(
          {String endPoint = 'https://appwrite.io/v1',
          bool selfSigned = false,
          req.Client? http}) =>
      createClient(endPoint: endPoint, selfSigned: selfSigned, http: http);

  Future init();

  /// Your project ID
  Client setProject(String value);

  /// Your secret JSON Web Token
  Client setJWT(String value);

  Client setLocale(value);

  Client setSelfSigned({bool status = true});

  Client setEndpoint(String endPoint);

  Future<req.Response> call(
    HttpMethod method, {
    String path = '',
    Map<String, String> headers = const {},
    Map<String, dynamic> params = const {},
    dio.ResponseType? responseType,
  });
}
